#!/usr/bin/perl
#-------------------------------------------------------------------------
#  Copyright 2007, NETGEAR
#  All rights reserved.
#-------------------------------------------------------------------------

do "/frontview/lib/cgi-lib.pl";
do "/frontview/lib/addon.pl";

# initialize the %in hash
%in = ();
ReadParse();

my $operation      = $in{OPERATION};
my $command        = $in{command};
my $enabled        = $in{"CHECKBOX_PINGSERVICE_ENABLED"};

get_default_language_strings("PINGSERVICE");
 
my $xml_payload = "Content-type: text/xml; charset=utf-8\n\n"."<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
 
if( $operation eq "get" )
{
  $xml_payload .= Show_PINGSERVICE_xml();
}
elsif( $operation eq "set" )
{
  if( $command eq "RemoveAddOn" )
  {
    # Remove_Service_xml() removes this add-on
    $xml_payload .= Remove_Service_xml("PINGSERVICE");
  }
  elsif ($command eq "ToggleService")
  {
    # Toggle_Service_xml() toggles the enabled state of the add-on
    $xml_payload .= Toggle_Service_xml("PINGSERVICE", $enabled);
  }
  elsif ($command eq "ModifyAddOnService")
  {
    # Modify_PINGSERVICE_xml() processes the input form changes
    $xml_payload .= Modify_PINGSERVICE_xml();
  }
}

print $xml_payload;
  

sub Show_PINGSERVICE_xml
{
  my $xml_payload = "<payload><content>" ;

  # check if service is running or not 
  my $enabled = GetServiceStatus("PINGSERVICE");

  # get PINGSERVICE_IP_ADDRESS parameter from /etc/default_services
  my $ip_address = GetValueFromServiceFile("PINGSERVICE_IP_ADDRESS");
  my $interval = GetValueFromServiceFile("PINGSERVICE_INTERVAL");
  
  if( $ip_address eq "not_found" )
  {
    # set ip_address to a default value
    $ip_address = "127.0.0.1";
  }

  if( $interval eq "not_found" )
  {
    # set ip_address to a default value
    $interval = "60";
  }

  my $enabled_disabled = "disabled";
     $enabled_disabled = "enabled" if( $enabled );

  # return ip_address value for HTML
  $xml_payload .= "<PINGSERVICE_IP_ADDRESS><value>$ip_address</value><enable>$enabled_disabled</enable></PINGSERVICE_IP_ADDRESS>"; 
  $xml_payload .= "<PINGSERVICE_INTERVAL><value>$interval</value><enable>$enabled_disabled</enable></PINGSERVICE_INTERVAL>";
  
  $xml_payload .= "</content><warning>No Warnings</warning><error>No Errors</error></payload>";
  
  return $xml_payload;
}


sub Modify_PINGSERVICE_xml 
{
  my $ip_address  = $in{"PINGSERVICE_IP_ADDRESS"};
  my $interval = $in{"PINGSERVICE_INTERVAL"};  
  my $SPOOL;
  my $xml_payload;
  
  $ip_address = "127.0.0.1" if( $ip_address eq "" );
  $interval = "60" if( $interval eq "" );
  
  $SPOOL .= "
if grep -q PINGSERVICE_IP_ADDRESS /etc/default/services; then
  sed -i 's/PINGSERVICE_IP_ADDRESS=.*/PINGSERVICE_IP_ADDRESS=${ip_address}/' /etc/default/services
else
  echo 'PINGSERVICE_IP_ADDRESS=${ip_address}' >> /etc/default/services
fi
";

  $SPOOL .= "
if grep -q PINGSERVICE_INTERVAL /etc/default/services; then
  sed -i 's/PINGSERVICE_INTERVAL=.*/PINGSERVICE_INTERVAL=${interval}/' /etc/default/services
else
  echo 'PINGSERVICE_INTERVAL=${interval}' >> /etc/default/services
fi
";
 
  if( $in{SWITCH} eq "YES" ) 
  {
    $xml_payload = Toggle_Service_xml("PINGSERVICE", $enabled);
  }
  else
  {
    spool_file("${ORDER_SERVICE}_PINGSERVICE", $SPOOL);
    empty_spool();

    $xml_payload = _build_xml_set_payload_sync();
  }
  return $xml_payload;
}


1;
